#!/usr/bin/perl

###############################################################################
# Greymatter 1.6.1                            
# Copyright (c)2000-2006, The Greymatter team 
# http://greymatterforum.proboards82.com/     
# By possessing this software, you agree not to hold the author responsible for 
# any problems that may arise from your installation or usage of Greymatter 
# itself, or from any content generated by yourself or others through the use of 
# this program.  You MAY freely modify and redistribute this program, so 
# long as every copyright notice (including in this manual and in the Greymatter 
# code) remains fully intact.  Finally, you may NOT sell or in any way 
# make a financial profit from this program, either in original or modified form.
# Your possession of this software signifies that you agree to these terms; 
# please delete your copy of this software if you don't agree to these terms.
# Original Creators Noah Grey
###############################################################################

use lib 'libs';

use CGI::Carp qw(fatalsToBrowser);
use Gm_Constants;
use Gm_Web;
use Gm_Core;

require "gm-library.cgi";

## TODO REFACTOR INTO WEB getWebParams
read(STDIN, $input, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $input);
foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	$name =~ tr/+/ /;
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$IN{$name} = $value;
}

$userip = $ENV{'REMOTE_ADDR'};
$authorIP = $userip || 'userip';

&gm_readconfig;
&gm_readtemplates;
&gm_readcounter;

if (($IN{'newcommentbody'} eq "") && ($IN{'newcommentauthor'} eq "") && ($IN{'gmsearch'} eq "")) {
	Gm_Web::displayUserErrorExit('No valid information was given.');
}

&gm_commentbancheck;

if ($IN{'gmsearch'} ne "") { &gm_searchresults; }

# as of 1.21e we check this beofre manipulating the comment text in any way.
&gm_phphackcheck;

# now gets tags with spaces
# and line breaks are handles via the /s modifier
$IN{'newcommentauthor'} =~      s(<[^>]*>)()gs;
$IN{'newcommentemail'} =~       s(<[^>]*>)()gs;
$IN{'newcommenthomepage'} =~    s(<[^>]*>)()gs;

$IN{'newcommentbody'} =~        s/\|\*\|/\n/g;

$IN{'newcommentauthor'} =~      s/{/(/g;
$IN{'newcommentemail'} =~       s/{/(/g;
$IN{'newcommenthomepage'} =~    s/{/(/g;
$IN{'newcommentbody'} =~        s/{/(/g;
$IN{'newcommentauthor'} =~      s/}/)/g;
$IN{'newcommentemail'} =~       s/}/)/g;
$IN{'newcommenthomepage'} =~    s/}/)/g;
$IN{'newcommentbody'} =~        s/}/)/g;
$IN{'newcommentauthor'} =~      s/{/(/g;
$IN{'newcommentemail'} =~       s/{/(/g;
$IN{'newcommenthomepage'} =~    s/{/(/g;
$IN{'newcommentbody'} =~        s/{/(/g;
$IN{'newcommentauthor'} =~      s/}/)/g;
$IN{'newcommentemail'} =~       s/}/)/g;
$IN{'newcommenthomepage'} =~    s/}/)/g;
$IN{'newcommentbody'} =~        s/}/)/g;

$IN{'newcommentauthor'} =~      s/\|//g;
$IN{'newcommentemail'} =~       s/\|//g;
$IN{'newcommenthomepage'} =~    s/\|//g;
$IN{'newcommentbody'} =~        s/\|//g;

$IN{'newcommentauthor'} =~      s/"/\&quot;/g;
$IN{'newcommentemail'} =~       s/"/\&quot;/g;
$IN{'newcommenthomepage'} =~    s/"/\&quot;/g;
$IN{'newcommentbody'} =~        s/"/\&quot;/g;

$IN{'newcommentauthor'} =~      s/^\s+//;
$IN{'newcommentauthor'} =~      s/\s+$//;
$IN{'newcommentemail'} =~       s/^\s+//;
$IN{'newcommentemail'} =~       s/\s+$//;
$IN{'newcommenthomepage'} =~    s/^\s+//;
$IN{'newcommenthomepage'} =~    s/\s+$//;
$IN{'newcommentbody'} =~        s/^\s+//;
$IN{'newcommentbody'} =~        s/\s+$//;

$IN{'newcommentauthor'} =~      s/\n//g;
$IN{'newcommentemail'} =~       s/\n//g;
$IN{'newcommenthomepage'} =~    s/\n//g;
$IN{'newcommentauthor'} =~      s/\r//g;
$IN{'newcommentemail'} =~       s/\r//g;
$IN{'newcommenthomepage'} =~    s/\r//g;

$IN{'newcommentbody'} =~        s/\r//g;
$IN{'newcommentbody'} =~        s/\n/\|\*\|/g;
$IN{'newcommentbody'} =~        s/(\|\*\|\|\*\|){2,}/\|\*\|\|\*\|/g;
$IN{'newcommentbody'} =~        s/\|\*\|\|\*\|\|\*\|/\|\*\|\|\*\|/g;


$temphomepageprefix = substr($IN{'newcommenthomepage'}, 0, 7);
if ($temphomepageprefix ne "http://") { $IN{'newcommenthomepage'} = "http://$IN{'newcommenthomepage'}"; }

if ($IN{'newcommenthomepage'} eq "http://") { $IN{'newcommenthomepage'} = ""; }

$newcommententrynumberpadded = sprintf ("%8d", $IN{'newcommententrynumber'});
$newcommententrynumberpadded =~ tr/ /0/;

## TODO: GET RED OF THIS, MUST MOVE COLLATE COMMENTS
open (FUNNYFEET, "$EntriesPath/$newcommententrynumberpadded.cgi") || 
	Gm_Web::displayUserErrorExit( "Can't open $EntriesPath/$newcommententrynumberpadded.cgi.".
	' Please make sure your paths are configured correctly and that your entries/archives'.
	'directory is CHMODed to 777.');
@entrylines = <FUNNYFEET>;
close (FUNNYFEET);

$gmcounter = 0;

foreach (@entrylines) {
	chomp ($entrylines[$gmcounter]);
	$gmcounter++;
}

# ($thisentrynumber, $thisentryauthor, $thisentrysubject, $thisentryweekdaynumber, 
# $thisentrymonth, $thisentryday, $thisentryyearyear, $thisentryhour, $thisentryminute, 
# $thisentrysecond, $thisentryampm, $thisentrypositivekarma, $thisentrynegativekarma, 
# $thisentrycommentsnumber, $thisentryallowkarma, $thisentryallowcomments, $thisentryopenstatus, 
# $thisentrymusic, $thisentrymood, $thisentryemoticonsallowed) = split (/\|/, $entrylines[0]);

my $gmEntry = Gm_Storage::getEntry( id=>$IN{'newcommententrynumber'},
	errHandler=>\&Gm_Web::displayUserErrorExit );

## TODO: refactor out usage of variables, make work directly off of entry
$thisentrynumber = $gmEntry->{'entryinfo'}{'id'};
$thisentryauthor = $gmEntry->{'entryinfo'}{'author'};
$thisentrysubject = $gmEntry->{'entryinfo'}{'subject'};
$thisentryweekdaynumber = $gmEntry->{'entryinfo'}{'weekday'};
$thisentrymonth = $gmEntry->{'entryinfo'}{'month'};
$thisentryday = $gmEntry->{'entryinfo'}{'day'};
$thisentryyearyear = $gmEntry->{'entryinfo'}{'year'};
$thisentryhour = $gmEntry->{'entryinfo'}{'hour'};
$thisentryminute = $gmEntry->{'entryinfo'}{'minute'};
$thisentrysecond = $gmEntry->{'entryinfo'}{'second'};
$thisentryampm = $gmEntry->{'entryinfo'}{'ampm'};
$thisentrypositivekarma = $gmEntry->{'entryinfo'}{'karmapos'};
$thisentrynegativekarma = $gmEntry->{'entryinfo'}{'karmaneg'};
$thisentrycommentsnumber = $gmEntry->{'entryinfo'}{'commenttotal'};
$thisentryallowkarma = $gmEntry->{'entryinfo'}{'karma'};
$thisentryallowcomments = $gmEntry->{'entryinfo'}{'comments'};
$thisentryopenstatus = $gmEntry->{'entryinfo'}{'status'};
$thisentrymusic = $gmEntry->{'entryinfo'}{'music'};
$thisentrymood = $gmEntry->{'entryinfo'}{'mood'};
$thisentryemoticonsallowed = $gmEntry->{'entryinfo'}{'emoticons'};


&gm_allowedcheck;
&gm_blankcheck;
&gm_authorcheck if $protectauthorname eq Gm_Constants::YES;

# allow graphic buttons for comment form: linear 
if ( ($IN{'gmpostpreview'} ne "") || ($IN{'gmpostpreview.x'} ne "") ) {	
	&gm_previewcomment;
} else {
	&gm_addcomment;
	&gm_freshenaftercomment;
}

# -------------
# check for ban
# -------------
# TODO: THIS IS VERY SIMILAR TO COMMENT BAN CHECK, THIS SHOULD BE GENERISIZED TO WEB (AND BE PASSED AN ACTION)
sub gm_commentbancheck {

	my $gmbanlist = Gm_Storage::getBanlist( errHandler=>\&Gm_Web::displayUserErrorExit );
	if( scalar( keys(%$gmbanlist)) > 0 ){
		foreach $gmbanlistline ( keys( %$gmbanlist ) ) {

			my ($checkthisip, $checkthisiphost, $checkthisperson) = 
				($gmbanlist->{$gmbanlistline}{'ip'}, $gmbanlist->{$gmbanlistline}{'host'}, 
				 $gmbanlist->{$gmbanlistline}{'label'} );

			if ($userip =~ m/$checkthisip/i) {
				if (($keeplog eq Gm_Constants::YES) && ($logkarmaandcomments eq Gm_Constants::YES)) {
					
					if ($checkthisperson ne "") { print FUNNYFEET ", \"$checkthisperson\""; }
						if ($IN{'gmsearch'} ne "") {
							Gm_Core::writeToCplog( "<FONT COLOR=\"#FF0000\"><b>A banned IP ".
								"($checkthisip/$checkthisiphost) attempted to search for \"$IN{'gmsearch'}\"</FONT></b>",
								\&Gm_Web::displayUserErrorExit );
						} else {
							Gm_Core::writeToCplog( "<FONT COLOR=\"#FF0000\"><B>A banned IP ".
								"($checkthisip/$checkthisiphost) attempted to post a comment to entry ".
								"#$IN{'newcommententrynumber'}</B> ($IN{'newcommentauthor'}: ".
								"$IN{'newcommentbody'})</FONT>",
								\&Gm_Web::displayUserErrorExit );
						}
					}	
				my $action = $IN{'gmsearch'} ? 'searching' : 'commenting';
				Gm_Web::displayUserErrorExit("You have been banned from $action on this site.<BR>(IP: $userip)");
			}
		}
	}
  
}

# -------------------------------
# check if comments can be posted
# -------------------------------

sub gm_allowedcheck {

if (($posttoarchives eq Gm_Constants::NO) && ($thisentrynumber <= $newarchivenumber)) {
	
	if (($keeplog eq Gm_Constants::YES) && ($logkarmaandcomments eq Gm_Constants::YES)) {
		Gm_Core::writeToCplog( "A comment was blocked from being added to archived entry ".
			"#$IN{'newcommententrynumber'} ($IN{'newcommentauthor'}: $IN{'newcommentbody'})",
			\&Gm_Web::displayUserErrorExit );
	}
	
	Gm_Web::displayUserErrorExit('Sorry - comments cannot be posted to archived '.
		'entries.  Please use your browser\'s Back button to return.');
}

if (($thisentryallowcomments eq Gm_Constants::NO) || ($generateentrypages eq Gm_Constants::NO) || 
	($thisentryopenstatus eq Gm_Constants::CLOSED) || ($allowkarmaorcomments eq Gm_Constants::KARMA) || 
	($allowkarmaorcomments eq Gm_Constants::NEITHER)) {

	if (($keeplog eq Gm_Constants::YES) && ($logkarmaandcomments eq Gm_Constants::YES)) {
		Gm_Core::writeToCplog( "A comment was blocked from being added to entry #$IN{'newcommententrynumber'} ".
			"($IN{'newcommentauthor'}: $IN{'newcommentbody'})",
			\&Gm_Web::displayUserErrorExit );
	}

	Gm_Web::displayUserErrorExit('Sorry - comments cannot be posted to this '.
		'entry.  Please use your browser\'s Back button to return.');
}

}

# ------------------------------
# check if name or body is blank
# ------------------------------
sub gm_blankcheck {
	if (($IN{'newcommentauthor'} eq "") || ($IN{'newcommentbody'} eq "")) {
		Gm_Web::displayUserErrorExit('You left either your name or your comments '.
			'blank.  Please use your browser\'s Back button to return.');
	}
}

# ------------------------------
# preview comment before posting
# ------------------------------

sub gm_previewcomment {

my ($skip, $wday, $mon, $mday, $JSYear, $hour, $min, $sec, $AMPM ) = 
	Gm_Utils::getStdDate( $serveroffset );

if ($thisentrymorebody ne "") {
	if ($thisentrynumber <= $newarchivenumber) {
		$commentpreviewpage = $gmmorearchiveentrypagetemplate;
	} else {
		$commentpreviewpage = $gmmoreentrypagetemplate;
	}
} else {
	if ($thisentrynumber <= $newarchivenumber) {
		$commentpreviewpage = $gmarchiveentrypagetemplate;
	} else {
		$commentpreviewpage = $gmentrypagetemplate;
	}
}

&gm_getentryvariables($IN{'newcommententrynumber'});

$thisentrycomments = "";
$thisentrycommentsnumber = 1;
$thispreviewcounter = $thisentrycommentsnumber + 3;

$IN{'newcommentauthor'} =~ s/\&quot;/"/g;
$IN{'newcommentemail'} =~ s/\&quot;/"/g;
$IN{'newcommenthomepage'} =~ s/\&quot;/"/g;
$IN{'newcommentbody'} =~ s/\&quot;/"/g;
$IN{'newcommentbody'} =~ s/\|\*\|/\n/g;

## Used by collatecomments
$entrylines[$thispreviewcounter] = "$IN{'newcommentauthor'}|$userip|$IN{'newcommentemail'}|$IN{'newcommenthomepage'}|$wday|$mon|$mday|$JSYear|$hour|$min|$sec|$AMPM|$IN{'newcommentbody'}";

$IN{'newcommentauthor'} =~ s/"/\&quot;/g;
$IN{'newcommentemail'} =~ s/"/\&quot;/g;
$IN{'newcommenthomepage'} =~ s/"/\&quot;/g;
$IN{'newcommentbody'} =~ s/"/\&quot;/g;
$IN{'newcommentbody'} =~ s/\n/\|\*\|/g;

$previewcommentauthor = $IN{'newcommentauthor_org'};
$previewcommentemail = $IN{'newcommentemail'};
$previewcommenthomepage = $IN{'newcommenthomepage'};
$previewcommentbody = $IN{'newcommentbody'};

&gm_collatecomments;

$commentpreviewpage =~ s/{{commentdivider}}/$gmcommentpreviewdividertemplate/gi;
$commentpreviewpage =~ s/{{entrycommentsform}}/$gmcommentpreviewformtemplate/gi;
$commentpreviewpage =~ s/{{previewcommentauthor}}/$previewcommentauthor/gi;
$commentpreviewpage =~ s/{{previewcommentemail}}/$previewcommentemail/gi;
$commentpreviewpage =~ s/{{previewcommenthomepage}}/$previewcommenthomepage/gi;
$commentpreviewpage =~ s/{{previewcommentbody}}/$previewcommentbody/gi;

&gm_formatentry($commentpreviewpage);

println( Gm_Web::createRequestHeader() );

print<<PREVIEWCOMMENT;

$entryreturn

PREVIEWCOMMENT

exit;

}

# --------------------------
# so add the comment already
# --------------------------

sub gm_addcomment {
	
#	$thisentrycommentsnumber++;
	
#	$entrylines[0] = "$thisentrynumber|$thisentryauthor|$thisentrysubject|$thisentryweekdaynumber|$thisentrymonth|$thisentryday|$thisentryyearyear|$thisentryhour|$thisentryminute|$thisentrysecond|$thisentryampm|$thisentrypositivekarma|$thisentrynegativekarma|$thisentrycommentsnumber|$thisentryallowkarma|$thisentryallowcomments|$thisentryopenstatus|$thisentrymusic|$thisentrymood|$thisentryemoticonsallowed";
	
#	$gmcounter = 0;
	my ($skip, $wday, $mon, $mday, $JSYear, $hour, $min, $sec, $AMPM ) = 
		Gm_Utils::getStdDate( $serveroffset );
# 	open (FUNNYFEET, ">$EntriesPath/$newcommententrynumberpadded.cgi") || 
# 		Gm_Web::displayUserErrorExit('Can\'t write to '.$EntriesPath.'/'.
# 		$newcommententrynumberpadded.cgi.'.  Please make sure that your paths are '.
# 		'configured correctly and that your entries/archives directory is CHMODed to 777.');
# 	foreach $entrynewline (@entrylines) { print FUNNYFEET "$entrynewline\n"; }
# 	print FUNNYFEET "$IN{'newcommentauthor'}|$userip|$IN{'newcommentemail'}|$IN{'newcommenthomepage'}|
#$wday|$mon|$mday|$JSYear|$hour|$min|$sec|$AMPM|$IN{'newcommentbody'}\n";
# 	close (FUNNYFEET);

my %comment = ();
$comment{'name'} = $IN{'newcommentauthor'};
$comment{'ip'} = $userip;
$comment{'email'} = $IN{'newcommentemail'};
$comment{'homepage'} = $IN{'newcommenthomepage'};
$comment{'weekday'} = $wday;
$comment{'month'} = $mon;
$comment{'day'} = $mday;
$comment{'year'} = $JSYear;
$comment{'hour'} = $hour;
$comment{'minute'} = $min;
$comment{'second'} = $sec;
$comment{'ampm'} = $AMPM;
$comment{'comment'} = $IN{'newcommentbody'};

Gm_Storage::addEntryComment( id=>$IN{'newcommententrynumber'}, %comment, 
	errHandler=>\&Gm_Web::displayAdminErrorExit );

}

# ------------------------
# primp, preen, take a bow
# ------------------------

sub gm_freshenaftercomment {

$newalltimecommentstotalnumber++;
&gm_writecounter;

$aftermath = "$EntriesWebPath/$newcommententrynumberpadded.$entrysuffix#comments";

&gm_getentryvariables($IN{'newcommententrynumber'});

if ($thisentrymorebody ne "") {
	if ($thisentrynumber <= $newarchivenumber) {
		&gm_formatentry($gmmorearchiveentrypagetemplate);
	} else {
		&gm_formatentry($gmmoreentrypagetemplate);
	}
} else {
	if ($thisentrynumber <= $newarchivenumber) {
		&gm_formatentry($gmarchiveentrypagetemplate);
	} else {
		&gm_formatentry($gmentrypagetemplate);
	}
}

open (THISFILE, ">$EntriesPath/$thisentrynumberpadded.$entrysuffix") || 
	Gm_Web::displayUserErrorExit('Can\'t write to '.
	"$EntriesPath/thisentrynumberpadded.$entrysuffix.  Please make sure that ".
	'your paths are configured correctly and that your entries/archives directory '.
	'is CHMODed to 777.');;
print THISFILE $entryreturn;
close (THISFILE);

if ($thisentrynumber <= $newarchivenumber) {
	&gm_readcounter;
	$stoppednumber = $newarchivenumber;
	do { &gm_generatearchive($stoppednumber); } until $stoppednumber <= 1;
} else {
	&gm_generatemainindex;
}

&gm_readconfig;

if (($NotifyForStatus eq Gm_Constants::COMMENTS) || ($NotifyForStatus eq Gm_Constants::BOTH)) {
if ($NotifyEmail ne "") {

$formattedcomment = $IN{'newcommentbody'};
$formattedcomment =~ s/\|\*\|/\n/g;
$sendithere = "$mailprog -t";

@sendestinations = split (/;/, $NotifyEmail);

&gm_getentryvariables($IN{'newcommententrynumber'});

foreach $destinationow (@sendestinations) {

## TODO: MAKE SENDING MAIL A CALL TO A SINGLE FUCNTION, IN CORE
open (MAIL, "|$sendithere") || 
	Gm_Web::displayUserErrorExit('Can\'t open the mail program at '.$mailprog.
	'. Please make sure you have this configured correctly.');
print MAIL <<__MAILNOTIFY__;
To: $destinationow
From: Greymatter <$destinationow>
Subject: [Greymatter] Notice: Comment Posted

A comment has just been posted to entry #$IN{'newcommententrynumber'} ($thisentrysubject).

Name: $IN{'newcommentauthor'} (IP: $userip)
E-Mail: $IN{'newcommentemail'}
Homepage: $IN{'newcommenthomepage'}

Comments: $formattedcomment

Posted to: $aftermath

-----
Greymatter $gmversion
http://noahgrey.com/greysoft/

__MAILNOTIFY__

close(MAIL);

}

}
}

if (($keeplog eq Gm_Constants::YES) && ($logkarmaandcomments eq Gm_Constants::YES)) {
	my ($gmdate) = Gm_Utils::getStdDate( $serveroffset );
	Gm_Core::writeToCplog( "<I>$IN{'newcommentauthor'} added a comment to entry #$IN{'newcommententrynumber'} ".
		"($thisentrysubject)</I>", \&Gm_Web::displayUserErrorExit );
}

print "Location: $aftermath\n\n";

}

# --------------
# search results
# --------------

sub gm_searchresults {

$searchmatchescount = 0;
$searchresultbody = "";

$IN{'gmsearch'} =~ s/\|//g;
# search robustness improvement: linear 9/19/2003 
# merged into 1.3
$IN{'gmsearch'} = quotemeta($IN{'gmsearch'});
# merged 9/19/2003

&gm_readconfig;
&gm_readcounter;
&gm_readtemplates;

$countfromhere = $newentrynumber;

do {

	&gm_getentryvariables($countfromhere);

	unless ($thisentryopenstatus eq Gm_Constants::CLOSED) {

		if (($thisentrysubject =~ m/$IN{'gmsearch'}/i) || ($thisentryauthor =~ m/$IN{'gmsearch'}/i) || ($thisentrymainbody =~ m/$IN{'gmsearch'}/i) || ($thisentrymorebody =~ m/$IN{'gmsearch'}/i) || ($thisentrycomments =~ m/$IN{'gmsearch'}/i) || ($thisentrymusic =~ m/$IN{'gmsearch'}/i) || ($thisentrymood =~ m/$IN{'gmsearch'}/i)) {

			&gm_formatentry($gmsearchresultsentrytemplate);
			$searchresultbody .= $entryreturn;
			$searchmatchescount++;

		}

	}

	$countfromhere--;

} until $countfromhere eq "0";

# XSS scripting mitigation: linear 7/7/2003
# merged into 1.3  
$IN{'gmsearch'} =~ s/</&lt;/g;
$IN{'gmsearch'} =~ s/>/&gt;/g;
# merged 9/11/2003 

$searchpage = $gmsearchresultspagetemplate;
$searchpage =~ s/{{searchterm}}/$IN{'gmsearch'}/g;
$searchpage =~ s/{{searchmatches}}/$searchmatchescount/g;
$searchpage =~ s/{{searchresults}}/$searchresultbody/g;
&gm_formatentry($searchpage);

println( Gm_Web::createRequestHeader() );

print<<SHOWSEARCHRESULTS;

$entryreturn

SHOWSEARCHRESULTS

if (($keeplog eq Gm_Constants::YES) && ($logkarmaandcomments eq Gm_Constants::YES)) {
	## do we really need to display an error on this?
	Gm_Core::writeToCplog( "<I>A search was performed for \"$IN{'gmsearch'}\" ".
		"($searchmatchescount matches)</I>", \&Gm_Web::displayUserErrorExit );
}

exit;
}

# ------------------------------ 
# check if there's a lame PHP tag attempt 
# script kiddie check added by linear 2/10/2003
# revised, enhanced, and improved by linear 7/7/2003
# ------------------------------ 
# merged into 1.3
sub gm_phphackcheck { 

if ( ($IN{'newcommentauthor'} =~ /<\?|<script|<%|<iframe/ ) || ($IN{'newcommentbody'} =~ /<\?|<script|<%|<iframe/ ) || ($IN{'newcommentemail'} =~ /<\?|<script|<%|<iframe/ ) || ($IN{'newcommenthomepage'} =~ /<\?|<script|<%|<iframe/ )) {
    my ($gmdate) = Gm_Utils::getStdDate( $serveroffset ); 

	println( Gm_Web::createRequestHeader() );
	println( Gm_Web::createUserError("We don't take kindly to that sort of activity here. ".
		"Your attempt to break the script has been logged and the administrators have ".
		"been notified. <br>[$gmdate] [$userip]"));    
 
    if ($mailhacknotice eq Gm_Constants::YES) {
    &gm_readconfig;
    if ($NotifyEmail ne "") {
        $sendithere = "$mailprog -t";
        @sendestinations = split (/;/, $NotifyEmail);
        foreach $destinationow (@sendestinations) {
            open (MAIL, "|$sendithere") || 
            	Gm_Web::displayUserErrorExit('Can\'t open the mail program at '.
            	$mailprog.'.  Please make sure you have this configured correctly.');
            print MAIL <<__MAILHACKNOTIFY__;
To: $destinationow
From: Greymatter <$destinationow>
Subject: [Greymatter] Notice: PHP hack attempt logged

A hacker was blocked from a PHP attack against entry #$IN{'newcommententrynumber'}

Name: $IN{'newcommentauthor'} (IP: $userip)
E-Mail: $IN{'newcommentemail'}
Homepage: $IN{'newcommenthomepage'}

Comments: $formattedcomment
       
-----
Greymatter $gmversion
http://noahgrey.com/greysoft/

__MAILHACKNOTIFY__

        close(MAIL);
            }
    
        }


	} 
    if ($keepphphacklog eq Gm_Constants::YES) { 
    # scrub the string a bit so we can log it cleanly
    $IN{'newcommentauthor'} =~ s/</&lt;/g;
    $IN{'newcommentauthor'} =~ s/>/&gt;/g;
	Gm_Core::writeToCplog( "<b>A script kiddie was blocked</b> from a PHP attack against entry ".
		"#$IN{'newcommententrynumber'} ($IN{'newcommentauthor'}: $IN{'newcommentbody'})",
		\&Gm_Web::displayUserErrorExit );
    } 
    exit;
    }
}
# merged 9/11/2003 

## GM Author Check
# Args: ?
# Will check that the commenters name does not contain an author name.  If it does
#  will check that the comment author string is "AUTHOR_PASSWORD" and use the password
#  to verify the identity of the author.
# Coldstone modified code from Stex
sub gm_authorcheck {

	## so that preview works, using org var, since we need to keep the 'Name_Pw'
	# note that we are _always_ setting this so that if we preview, a valid value
	# goest into the commentauthorname isn't a gm author ...
	$IN{'newcommentauthor_org'} = $IN{'newcommentauthor'};

	my $gmauthors = Gm_Storage::getAuthors( errHandler=>\&Gm_Web::displayUserErrorExit );	

	foreach my $author ( keys( %$gmauthors ) ) {
		my $a_name = $gmauthors->{$author}{'author'};
		my $a_password = $gmauthors->{$author}{'password'};
		my $a_email = $gmauthors->{$author}{'email'};
		my $a_homepage = $gmauthors->{$author}{'homepage'};
		
		## we are doing a regex to get a match since we don't want to be fooled by leading spaces (or case)
		if ($IN{'newcommentauthor'} =~ m/$a_name/i) {
			## We got an athor name match, lets check the pw
			# the pw will be attached to the endof the author name, seperated by '_'
			my( $author, $auth_pw ) = split( '_', $IN{'newcommentauthor'} );
			my $commentpassword = crypt($auth_pw, $auth_pw);
			
			## hmm, we are checking if the password matches both the plain and the crypted, no idea why...
			if ( ($a_password eq $commentpassword) || ($a_password eq $auth_pw) ){
				$IN{'newcommentauthor'} = $a_name;
				$IN{'newcommenthomepage'} = $a_homepage;
				$IN{'newcommentemail'}= $a_email;
			} else {
				println( Gm_Web::createRequestHeader() );
				println( Gm_Web::createUserError('You cannot use that name to '.
					'post a comment without the correct password. Please pick '.
					'another name or check your password.' ));

				## Good to let someone know that people are trying to impersonate
				Gm_Core::writeToCplog( "<B><FONT COLOR=\"#dd0000\">Invalid Password commenting on entry ".
					"#$IN{'newcommententrynumber'}:</font></B> $IN{'newcommentauthor'} ", 
					\&Gm_Web::displayUserErrorExit );
				exit;
			}
		}
	}
}
